#include <config.h>
#include <common.h>
#include <command.h>
#include <environment.h>
#include <linux/ctype.h>
#include <mmc.h>
#include <xsvf.h>

DECLARE_GLOBAL_DATA_PTR;

#ifdef CONFIG_CMD_XSVF

#if 0
/* xsvf <addr> [ mmc0 | mmc1 [ <offset> ] ] */
int do_xsvf(cmd_tbl_t *cmdtp, int flag, int argc, char *argv[])
{
	unsigned addr = 0x10800000;
	unsigned offset = 0;
	char *xsvf_env_str;
	int mmcc = -1;

	if (argc < 2)
		return -1;

	if (!strncmp(argv[1], "mmc", 3))
		mmcc = simple_strtoul(argv[1]+3, NULL, 10);
	else
		addr = simple_strtoul(argv[1], NULL, 16);

	if (argc > 2)
		offset = simple_strtoul(argv[2], NULL, 16);

	if (mmcc != -1) {
		struct mmc *mmc;
		block_dev_desc_t *dev_desc = NULL;
		unsigned xsvflen = 0x800;

		mmc = find_mmc_device(mmcc);
		if (!mmc) {
			printf("xsvf: cannot find '%d' mmc device\n", mmcc);
			goto fail;
		}
		dev_desc = get_dev("mmc", mmcc);
		if (NULL == dev_desc) {
			printf("** Block device MMC %d not supported\n", mmcc);
			goto fail;
		}

		/* below was i.MX mmc operation code */
		if (mmc_init(mmc)) {
			printf("mmc%d init failed\n", mmcc);
			goto fail;
		}
		if (offset == 0) {
			if ((xsvf_env_str = getenv("xsvfstart")) != NULL) {
				offset = simple_strtoul(xsvf_env_str, NULL, 16);
			} else {
				offset = 0x800;
			}
		}
		if ((xsvf_env_str = getenv("xsvfloadaddr")) != NULL) {
			addr = simple_strtoul(xsvf_env_str, NULL, 16);
		}
		if ((xsvf_env_str = getenv("xsvflen")) != NULL) {
			xsvflen = simple_strtoul(xsvf_env_str, NULL, 16);
		}

		if (mmc->block_dev.block_read(mmcc, offset, xsvflen, (void*)addr) < 0) {
			printf("xsvf: mmc failed to read xsvf file\n");
			goto fail;
		}
			/* flush cache after read */
		flush_cache((ulong)addr, 512 * xsvflen); /* FIXME */
	}
        
	if (xsvfExecute((unsigned char *)addr, 0) == XSVF_ERROR_NONE) {
		return 1;
	}
fail:
	return -1;
}
#endif

int do_xsvf(cmd_tbl_t *cmdtp, int flag, int argc, char *argv[])
{
    unsigned addr = 0x20000000;
    if (xsvfExecute((unsigned char *)addr, 0) == XSVF_ERROR_NONE) {
        return 1;
    }
    return -1;
}


int load_xsvf(void)
{
	char *argv[] = {"xsvf", "mmc2", "0x800", NULL};
	return do_xsvf(NULL, 0, 3, argv);
}

U_BOOT_CMD(
	xsvf,	3,	1,	do_xsvf,
	"xsvf   - load xsvf file and configure xilinx FPGA device\n",
	"[<addr> | mmc0 | mmc1 | mmc2 | mmcX] [<offset>] \n"
);
#endif	/* CMD_XSVF */
