#include "lenval.h"
#include "ports.h"

long value( lenVal*     plvValue )
{
    long    lValue;
    short   sIndex;

    lValue  = 0;
    for ( sIndex = 0; sIndex < plvValue->len ; ++sIndex )
    {
        lValue <<= 8;
        lValue |= plvValue->val[ sIndex];
    }
    return( lValue );
}

void initLenVal( lenVal*    plv,
                 long       lValue )
{
    plv->len    = 1;
    plv->val[0] = (unsigned char)lValue;
}

short EqualLenVal( lenVal*  plvTdoExpected,
                   lenVal*  plvTdoCaptured,
                   lenVal*  plvTdoMask )
{
    short           sEqual;
    short           sIndex;
    unsigned char   ucByteVal1;
    unsigned char   ucByteVal2;
    unsigned char   ucByteMask;

    sEqual  = 1;
    sIndex  = plvTdoExpected->len;

    while ( sEqual && sIndex-- )
    {
        ucByteVal1  = plvTdoExpected->val[ sIndex ];
        ucByteVal2  = plvTdoCaptured->val[ sIndex ];
        if ( plvTdoMask )
        {
            ucByteMask  = plvTdoMask->val[ sIndex ];
            ucByteVal1  &= ucByteMask;
            ucByteVal2  &= ucByteMask;
        }
        if ( ucByteVal1 != ucByteVal2 )
        {
            sEqual  = 0;
        }
    }

	return( sEqual );
}

short RetBit( lenVal*   plv,
              int       iByte,
              int       iBit )
{
    return( (short)( ( plv->val[ iByte ] >> ( 7 - iBit ) ) & 0x1 ) );
}

void SetBit( lenVal*    plv,
             int        iByte,
             int        iBit,
             short      sVal )
{
    unsigned char   ucByteVal;
    unsigned char   ucBitMask;

    ucBitMask   = (unsigned char)(1 << ( 7 - iBit ));
    ucByteVal   = (unsigned char)(plv->val[ iByte ] & (~ucBitMask));

    if ( sVal )
    {
        ucByteVal   |= ucBitMask;
    }
    plv->val[ iByte ]   = ucByteVal;
}

void addVal( lenVal*    plvResVal,
             lenVal*    plvVal1,
             lenVal*    plvVal2 )
{
	unsigned char   ucCarry;
    unsigned short  usSum;
    unsigned short  usVal1;
    unsigned short  usVal2;
	short           sIndex;
	
	plvResVal->len  = plvVal1->len;

    ucCarry = 0;
    sIndex  = plvVal1->len;
    while ( sIndex-- )
    {
		usVal1  = plvVal1->val[ sIndex ];
		usVal2  = plvVal2->val[ sIndex ];
		
		usSum   = (unsigned short)( usVal1 + usVal2 + ucCarry );
		
		ucCarry = (unsigned char)( ( usSum > 255 ) ? 1 : 0 );

		plvResVal->val[ sIndex ]    = (unsigned char)usSum;
    }
}

void readVal( lenVal*   plv,
              short     sNumBytes )
{
    unsigned char*  pucVal;
	
    plv->len    = sNumBytes;
    for ( pucVal = plv->val; sNumBytes; --sNumBytes, ++pucVal )
    {
		readByte( pucVal );
    }
}

